> ## Documentation Index > Fetch the complete documentation index at: https://help.commbox.io/llms.txt > Use this file to discover all available pages before exploring further. # Send WhatsApp Templated Message V2 > This API sends a generated WhatsApp template from the **WhatsApp Business Account** (WABA) to a single recipient or to multiple recipients (up to 20).

**Key New Capabilities of V2 version**

Marketing and Utility Templates may have a header with text or added media (attached document, image, or video), a footer, and a call for action or quick reply buttons.
The API can also create CommBox object(s), support subchannels, and enable scheduled publishing by adding unix timestamp code to the schedule field (see the 'Send a template with text' example).


**Send Templated Message + Object data**

Sending any templated WhatsApp message with Object data also creates a conversation (Object) on the CommBox platform.

**Note:** Adding the **ManagerId** field with the agent’s Id (optional) will ensure the agent is reflected in various reports. Objects without a managerId will display conversations as being initiated by 'customer'.

The required and optional fields are described here: https://www.commbox.io/api/#operation/Create_Object

**Send Templated Message with an Attached Media**

There are two ways to do so: a) Sending a Templated Message with a link to the file. Example below: 'Send a template with an attachment (doc)'.

OR
b) Use the /whatsapp/uploadmedia/{ENCRYPTED_STREAM_ID} API endpoint to upload the file to WhatsApp servers and then fetch the uploaded file ID from the response for sending a templated message with the attachment ID. See the 'Send a template with an attachment ID (video)' example.

**Authentication Templates**

See the Examples for sending an authentication template.

For more information:
  • https://help.commbox.io/docs/creating-new-whatsapp-authentication-templates
  • https://developers.facebook.com/docs/whatsapp/updates-to-pricing/new-template-guidelines/#authentication-templates ## OpenAPI ````json POST /v2/whatsapp/sendtemplatedmessage/{ENCRYPTED_STREAM_ID} { "openapi": "3.0.3", "info": { "title": "CommBox API", "x-logo": { "url": "https://www.commbox.io/logo/commbox_logo_large.png" }, "version": "2.07", "termsOfService": "https://www.commbox.io/end-user-license-agreement-eula/", "contact": { "name": "commbox", "url": "https://www.commbox.io", "email": "contactus@commbox.io" } }, "servers": [ { "url": "https://api.commbox.io/", "description": "Production server" } ], "security": [ { "BearerAuth": [] } ], "tags": [ { "name": "Core", "description": "

    Systemwide verification" }, { "name": "Objects", "description": "

    Objects are conversations between the AI Agent or the human agent and the customers, where each segment of the conversation is referred to as a Child. Every conversation must have a designated Stream – a communication channel such as Chat, Email, Text/SMS, etc., through which the conversation takes place.
    The Object APIs category concentrates on a specific conversation, where the Stream is part of the identifying parameters. In contrast, the Streams APIs category, the Channel is the focal point of the request, and the objects and users are the filtering aspects." }, { "name": "Media", "description": "Converting media files to Base64" }, { "name": "AI Services", "description": "APIs that provide AI capabilities by the platform. " }, { "name": "Streams", "description": "

    Streams are communication channels used in CommBox, such as Chat, WhatsApp, SMS/Text, etc. In the Streams category of APIs, the channel is the focal point of the request, and the objects and users are the filtering aspects. See the Enums Section for available channels and their CommBox code." }, { "name": "Tags", "description": "

    Tags are a classification tool for summarizing aspects of the conversation or the user. It can mark the conversation to indicate a new sale or identify a customer as not interested in the product. To help manage the Tags assets, Tags can be grouped with a common identifier." }, { "name": "SMS", "description": "

    Sending customers **SMS messages** (Texting) requires an initial opt-in step, which is not offered by CommBox and is the sole responsibility of the sending entity (Business)." }, { "name": "WhatsApp", "description": "

    CommBox facilitates activities in **WABA** for the clients. Our platform helps clients create new templates and manage existing ones.

    **Opt-in for WhatsApp**
    Before sending WhatsApp messages to someone, you must first receive opt-in permission confirming that they wish to receive future messages from you on WhatsApp. This can be done using any channel your business uses to communicate with people — your website, app, email, retail location, etc.